#include <NDS/NDS.h>
#include <ds_misc.h>
#include "c_defs.h"

extern u16 font;
extern u16 fontpal;

//sloppy :P  fix me some year
void fifo_send(u32 msgID,u32 msg) {
	u16 cnt=REG_FIFO_CNT;
	if(cnt&FIFO_CNT_ERR)
		REG_FIFO_CNT=cnt|FIFO_CNT_SEND_CLEAR;
	if(!(cnt&FIFO_CNT_SEND_FULL))
		REG_FIFO_SEND=msgID|(msg<<8);
}

void showconsole() {
	clearconsole();
	POWER_CR|=POWER_2D_SUB;
	SUB_DISPLAY_CR=MODE_0_2D|DISPLAY_BG0_ACTIVE|DISPLAY_BG1_ACTIVE|DISPLAY_WIN0_ON;
	SUB_BG0_CR=BG_TILE_BASE(1)|BG_64x32;
	SUB_BG1_CR=BG_TILE_BASE(1)|BG_64x32;
	SUB_BG0_X0=0;
	SUB_BG0_Y0=0;
	SUB_BG1_X0=0;
	SUB_BG1_Y0=0;

	SUB_WIN0_X0=0;
	SUB_WIN0_X1=255;
	SUB_WIN0_Y0=24;
	SUB_WIN0_Y1=191;
	SUB_WIN_IN=1;
	SUB_WIN_OUT=2;

	swiWaitForVBlank();
	swiWaitForVBlank();
	fifo_send(FIFO_WRITEPM,PM_BOTTOMLIGHT|PM_TOPLIGHT|PM_SOUND);
}
void hideconsole() {
	swiWaitForVBlank();
	POWER_CR&=~POWER_2D_SUB;
	fifo_send(FIFO_WRITEPM,PM_TOPLIGHT|PM_SOUND);
}

void clearconsole() {
	int i=0x00200020;
	swiFastSet(&i,SUB_BG+64*3,64*21,1);
	SUB_BG0_Y0=0;
}

void consoleinit() {
	dmaCopyHalfWords(3,&font,(u16*)(SUB_CHR+0x400),1024*4);
	dmaCopyHalfWords(3,&fontpal,(u16*)BG_PALETTE_SUB,128);
	showconsole();
}

void menutext(int line,char *s,int selected) {
	int color=selected?0x1000:0;
	u16 *p=(u16*)(SUB_BG+line*64);
	u16 *p2=p+32;
	u16 c;
	
	if(!selected) c=' ';
	else if(selected==1) c='*'|0x1000;	//normal selected look
	else if(selected==2) c='<'|0x1000;	//directory selected
	*p++=c;
	
	while(*s && p<p2) {
		*p++ = (*s++)|color;
	}
	if(selected==2)
		*p++ = '>'|color;
	while(p<p2)
		*p++=' ';
}

void consoletext(int offset,char *s,int color) {
	u16 *p;
	p=(u16*)(SUB_BG+offset);
	while(*s) {
		*p++ = (*s++)|color;
	}
}

void hex(int offset,int d,int n) {
	u16 *p;
	u16 c;
	p=(u16*)(SUB_BG+offset);
	do {
		c=d&0x0f;
		if(c<10) c+='0';
		else c=c-10+'A';
		d>>=4;
		p[n--]=c;
	} while(n>=0);
}
