;---------------------------------------
;dummy DLDI driver
;---------------------------------------
	AREA |.text|, CODE, align=4
	CODE32

	EXPORT DLDI_string
	EXPORT DLDI_interface
	
_dldi_start

;---------------------------------------------------------------------------------
; Standard header -- 64 bytes

	dcd 0xBF8DA5ED		; Magic number to identify this region
	dcb " Chishm",0		; Identifying Magic string
	dcb 0x01		; Version number
	dcb 0x0f		; Log [base-2] of the size of this driver in bytes
	dcb 0x00		; Sections to fix
	dcb 0x0f		; Log [base-2] of the allocated space in bytes

DLDI_string
	dcb "No DLDI driver"	;Interface string (48 bytes)
	% 48-15
	
;---------------------------------------------------------------------------------
; Offsets to important sections within the data	-- 32 bytes

	dcd _dldi_start		; data start
	dcd _dldi_end		; data end
	dcd 0x00000000		; Interworking glue start	-- Needs address fixing
	dcd 0x00000000		; Interworking glue end
	dcd 0x00000000		; GOT start			-- Needs address fixing
	dcd 0x00000000		; GOT end
	dcd 0x00000000		; bss start			-- Needs setting to zero
	dcd 0x00000000		; bss end

;---------------------------------------------------------------------------------
; IO_INTERFACE data -- 32 bytes

DLDI_interface
	dcb "DLDI"			; ioType
	dcd 0x00000000			; Features
	dcd _DLDI_startup			; 
	dcd _DLDI_isInserted		; 
	dcd _DLDI_readSectors		;   Function pointers to standard device driver functions
	dcd _DLDI_writeSectors		; 
	dcd _DLDI_clearStatus		; 
	dcd _DLDI_shutdown			; 
;---------------------------------------------------------------------------------
_DLDI_startup
_DLDI_isInserted
_DLDI_readSectors
_DLDI_writeSectors
_DLDI_clearStatus
_DLDI_shutdown
	mov		r0, #0x00				; Return false for every function
	bx		lr
;---------------------------------------------------------------------------------
	% 32768-136
_dldi_end
	END