	GBLL PPU_S
	
	INCLUDE equates.h
	INCLUDE import.h

	EXPORT scaletable
	EXPORT PPU_init
	EXPORT PPU_reset
	EXPORT PPU_R
	EXPORT PPU_W
	EXPORT agb_nt_map
	EXPORT vram_map
	EXPORT vram_write_tbl
	EXPORT VRAM_chr
	EXPORT newframe
	EXPORT agb_pal
	EXPORT writeBG
	EXPORT ctrl1_W
	EXPORT EMU_VBlank
	EXPORT ppusync
	EXPORT rescale
	EXPORT bg_chr_req
	
	EXPORT chr0_
	EXPORT chr1_
	EXPORT chr2_
	EXPORT chr3_
	EXPORT chr4_
	EXPORT chr5_
	EXPORT chr6_
	EXPORT chr7_
	EXPORT chr01_
	EXPORT chr23_
	EXPORT chr45_
	EXPORT chr67_
	EXPORT chr0123_
	EXPORT chr4567_
	EXPORT chr01234567_
	EXPORT updateBGCHR
	EXPORT updateOBJCHR
	EXPORT mirror1_
	EXPORT mirror2V_
	EXPORT mirror2H_
	EXPORT mirror4_
	EXPORT mirrorKonami_
	EXPORT vrommask
	EXPORT vrombase
	EXPORT agb_bg_map
	EXPORT resetCHR
	EXPORT writeCHRTBL
	EXPORT unpack_tiles

	AREA |.text|, CODE

nes_rgb15
	INCBIN nespal.bin
nes_rgb
	DCB 117,117,117, 39,27,143, 0,0,171, 71,0,159, 143,0,119, 171,0,19, 167,0,0, 127,11,0
	DCB 67,47,0, 0,71,0, 0,81,0, 0,63,23, 27,63,95, 0,0,0, 31,31,31, 5,5,5
	DCB 188,188,188, 0,115,239, 35,59,239, 131,0,243, 191,0,191, 231,0,91, 219,43,0, 203,79,15
	DCB 139,115,0, 0,151,0, 0,171,0, 0,147,59, 0,131,139, 49,49,49, 9,9,9, 9,9,9
	DCB 255,255,255, 63,191,255, 95,151,255, 167,139,253, 247,123,255, 255,119,183, 255,119,99, 255,155,59
	DCB 243,191,63, 131,211,19, 79,223,75, 88,248,152, 0,235,219, 102,102,102, 13,13,13, 13,13,13
	DCB 255,255,255, 171,231,255, 199,215,255, 215,203,255, 255,199,255, 255,199,219,255, 191,179,255, 219,171
	DCB 255,231,163, 227,255,163, 171,243,191, 179,255,207, 159,255,243, 209,209,209, 17,17,17, 17,17,17

DISPCNT_INIT EQU 0x0010		;1D OBJ

;----------------------------------------------------------------------------
remap_pal
;----------------------------------------------------------------------------
	ldr r5,=nes_rgb
	ldr r6,=MAPPED_RGB
	mov r7,#64*3
nomap
	ldr r0,[r5],#4
	str r0,[r6],#4
	subs r7,r7,#4
	bne nomap
	mov pc,lr
;----------------------------------------------------------------------------
paletteinit;	r0-r3 modified.
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r8,lr}
	bl remap_pal
	ldr r8,=NDS_PALETTE+0x100
	adr r6,nes_rgb15
	mov r4,#64
gloop0
	ldrh r0,[r6],#2
	strh r0,[r8],#2
	subs r4,r4,#1
	bne gloop0

	ldr r6,=MAPPED_RGB
	mov r7,r6
	mov r1,#0 ;ldrb r1,gammavalue	;gamma value = 0 -> 4
	mov r4,#64			;pce rgb, r1=R, r2=G, r3=B
gloop					;map 0bbbbbgggggrrrrr  ->  0bbbbbgggggrrrrr
	ldrb r0,[r6],#1
	bl gammaconvert
	mov r5,r0

	ldrb r0,[r6],#1
	bl gammaconvert
	orr r5,r5,r0,lsl#5

	ldrb r0,[r6],#1
	bl gammaconvert
	orr r5,r5,r0,lsl#10

	strh r5,[r7],#2
	strh r5,[r8],#2
	subs r4,r4,#1
	bne gloop

	ldmfd sp!,{r4-r8,lr}
	bx lr
;----------------------------------------------------------------------------
gammaconvert;	takes value in r0(0-0xFF), gamma in r1(0-4),returns new value in r0=0x1F
;----------------------------------------------------------------------------
	rsb r2,r0,#0x100
	mul r3,r2,r2
	rsbs r2,r3,#0x10000
	rsb r3,r1,#4
	orr r0,r0,r0,lsl#8
	mul r2,r1,r2
	mla r0,r3,r0,r2
	mov r0,r0,lsr#13

	bx lr
;----------------------------------------------------------------------------
PPU_init	;only need to call once
;----------------------------------------------------------------------------
	stmfd sp!,{lr}
	
	mov r1,#0xffffff00		;build chr decode table
	ldr r2,=CHR_DECODE
ppi0	mov r0,#0
	tst r1,#0x01
	orrne r0,r0,#0x10000000
	tst r1,#0x02
	orrne r0,r0,#0x01000000
	tst r1,#0x04
	orrne r0,r0,#0x00100000
	tst r1,#0x08
	orrne r0,r0,#0x00010000
	tst r1,#0x10
	orrne r0,r0,#0x00001000
	tst r1,#0x20
	orrne r0,r0,#0x00000100
	tst r1,#0x40
	orrne r0,r0,#0x00000010
	tst r1,#0x80
	orrne r0,r0,#0x00000001
	str r0,[r2],#4
	adds r1,r1,#1
	bne ppi0

	ldr r0,=DISPCNT_INIT		;clear HDMA buffers
	orr r0,r0,r0,lsl#16
	ldr r1,=DISPCNTBUFF
	mov r2,#120
	bl filler
	mov r0,#0
	ldr r1,=BGCNTBUFF
	mov r2,#(240*16)/4
	bl filler

	mov r1,#REG_BASE
	ldr r0,=0x2f2c			;set up window for 8-pixel border on left edge
	strh r0,[r1,#REG_WININ]		;WIN0 masks BG+sprites, WIN1 masks sprites
	ldr r0,=0x3f3f			;(not 100% accurate because of priority weirdness, but close enough)
	strh r0,[r1,#REG_WINOUT]
	mov r0,#8
	strh r0,[r1,#REG_WIN0H]
	strh r0,[r1,#REG_WIN1H]
	mov r0,#192
	strh r0,[r1,#REG_WIN0V]	
	strh r0,[r1,#REG_WIN1V]
		
	ldmfd sp!,{pc}
;----------------------------------------------------------------------------
rescale		;r0=scale, r1=starting Y<<16
;----------------------------------------------------------------------------
	ldr r2,scale
	and r2,r2,#1
	bic r0,r0,#1
	orr r0,r0,r2
	str r0,scale
	str r1,DMAlinestart
	
	stmfd sp!,{r4-r8,lr}
	
		add r8,r1,#0x8000
	mov r2,#0		;line counter
	adr r3,scaletable
		adr r7,scaletable2
	ldr r5,=spriteY_lookup
	mov r6,#0		;zero

rs1	movs r4,r1,asr#16
	strplb r4,[r3,r2]
	strmib r6,[r3,r2]
		movs r4,r8,asr#16
		strplb r4,[r7,r2]
		strmib r6,[r7,r2]
	add r4,r4,#1
	strb r4,[r5,r2]
	add r1,r1,r0
		add r8,r8,r0
	add r2,r2,#1
	cmp r2,#256
	bcc rs1
		
	mov r1,#REG_BASE	;change blend control for scaling type
	ldr r0,=emuflags
	ldr r0,[r0]
	tst r0,#ALPHALERP
	ldrne r2,=0x08082243
	ldreq r2,=0x10000310
	str r2,[r1,#REG_BLDCNT]

	ldmfd sp!,{r4-r8,pc}
;----------------------------------------------------------------------------
PPU_reset
;----------------------------------------------------------------------------
	stmfd sp!,{lr}
	
	mov r0,#0
	strb r0,ppuctrl0	;NMI off
	strb r0,ppuctrl1	;screen off
	strb r0,ppustat		;flags off

	mov r0,#0
	ldr r1,=NES_VRAM
	mov r2,#0x3000/4
	bl filler		;clear nes VRAM

	mov r0,#0xe0
	mov r1,#NDS_OAM
	mov r2,#0x100
	bl filler		;clear OAM

	bl paletteinit		;do palette mapping (for VS) & gamma
	
	ldmfd sp!,{pc}
;----------------------------------------------------------------------------
EMU_VBlank	;call every vblank
;----------------------------------------------------------------------------
	stmfd sp!,{r4-r7,lr}

	ldr r0,=emuflags
	ldr r0,[r0]
	tst r0,#NOFLICKER
	bne ev0
		ldr r1,scale		;for flicker scaling
		eor r1,r1,#1
		str r1,scale
ev0
	;ldr r0,emuflags
	;tst r0,#PALTIMING
	;beq nopal60
	;ldrb r0,PAL60
	;add r0,r0,#1
	;cmp r0,#6
	;movpl r0,#0
	;strb r0,PAL60
nopal60
	mov r2,#REG_BASE
	strh r2,[r2,#REG_DM0CNT_H]	;DMA stop
	strh r2,[r2,#REG_DM1CNT_H]
	strh r2,[r2,#REG_DM2CNT_H]
	strh r2,[r2,#REG_DM3CNT_H]

	add r1,r2,#REG_BG0CNT		;DMA0 -> BGxCNT + BGxOFS
	str r1,[r2,#REG_DM0DAD]
	ldr r0,=BGCNTBUFF
	ldmia r0!,{r3-r6}
	stmia r1,{r3-r6}			;set 1st values manually, HBL is AFTER 1st line
	str r0,[r2,#REG_DM0SAD]
	ldr r0,=0x96600004			;noIRQ hblank 32bit repeat incsrc inc_reloaddst, 4 word transfer
	str r0,[r2,#REG_DM0CNT_L]		;DMA0 start

	str r2,[r2,#REG_DM1DAD]		;DMA1 -> DISPCNT (BG/OBJ enable)
	ldr r1,=DISPCNTBUFF
	ldrh r0,[r1],#2
	strh r0,[r2,#REG_DISPCNT]		;set 1st value manually, HBL is AFTER 1st line
	str r1,[r2,#REG_DM1SAD]
	ldr r0,=0x92400001			;noIRQ hblank 16bit repeat incsrc fixeddst, 1 word transfer
	str r0,[r2,#REG_DM1CNT_L]		;DMA1 start

	DEBUGCOUNT VBLS
	ldmfd sp!,{r4-r7,pc}
;----------------------------------------------------------------------------
ppusync		;called on NES scanline 0..239 (r0=line)
;----------------------------------------------------------------------------
	stmfd sp!,{r3,lr}

	bl updateBGCHR		;check for bankswitching
		
	ldr r1,scale
	ldr r2,DMAline
	add r2,r2,r1
	str r2,DMAline
	
	movs r0,r2,asr#16
	movmi r0,#0
	add r2,r2,#0x8000
	movs r1,r2,asr#16
	movmi r1,#0		;r0,r1=scaled line
	
	;- - - 
	
	ldr r12,=DISPCNTBUFF
	add r12,r12,r0,lsl#1
	ldr r2,dispcnt
	strh r2,[r12]

	;- - -

	ldr r12,=BGCNTBUFF
		add lr,r12,r1,lsl#4
	add r12,r12,r0,lsl#4
		
	ldr r2,currentBG
	ldr r3,bg0cnt
	orr r2,r2,r3
	strh r2,[r12]
		strh r2,[lr,#2]
	
	;- - -
	
	ldr r2,scrollX
	strh r2,[r12,#8]
		strh r2,[lr,#12]
	
	ldr r2,scrollY
	sub r3,r2,r0
	strh r3,[r12,#10]
		sub r3,r2,r1
		strh r3,[lr,#14]
	
	add r2,r2,#1
	tst r2,#0xff
	eoreq r2,r2,#0x100	;page wraps with negative scroll
	cmp r2,#0xf0
	cmpne r2,#0x1f0
	addeq r2,r2,#16
	
	str r2,scrollY

	;- - -
		
	ldmfd sp!,{r3,pc}

scale DCD 0		;bit0=even/odd
DMAline DCD 0
DMAlinestart DCD 0
	
scaletable % 256
scaletable2 % 256
;----------------------------------------------------------------------------
PPU_R;
;----------------------------------------------------------------------------
	and r0,addy,#7
	ldr pc,[pc,r0,lsl#2]
	DCD 0
PPU_read_tbl
	DCD empty_PPU_R	;$2000
	DCD empty_PPU_R	;$2001
	DCD stat_R	;$2002
	DCD empty_PPU_R	;$2003
	DCD empty_PPU_R	;$2004
	DCD empty_PPU_R	;$2005
	DCD empty_PPU_R	;$2006
	DCD vmdata_R	;$2007
;----------------------------------------------------------------------------
PPU_W;
;----------------------------------------------------------------------------
	and r2,addy,#7
	ldr pc,[pc,r2,lsl#2]
	DCD 0
PPU_write_tbl
	DCD ctrl0_W	;$2000
	DCD ctrl1_W	;$2001
	DCD void	;$2002
	DCD void	;$2003
	DCD void	;$2004
	DCD bgscroll_W	;$2005
	DCD vmaddr_W	;$2006
	DCD vmdata_W	;$2007
;----------------------------------------------------------------------------
empty_PPU_R
;----------------------------------------------------------------------------
	mov r0,#0
	mov pc,lr
;----------------------------------------------------------------------------
ctrl0_W		;(2000)
;----------------------------------------------------------------------------
	stmfd sp!,{lr}
;c02:
;	and al,[ctrl0]
;	and al,[stat]
;	jns c03
;	or [int_flags],NMI ;NMI when NMIen&VBLflag=0->1

	strb r0,ppuctrl0

	mov r1,#1			;+1/+32
	tst r0,#4
	movne r1,#32
	strb r1,vramaddrinc

	mov r1,r0,lsr#1
	and r1,r1,#1
	strb r1,scrollYtemp+1		;Y scroll

	and r0,r0,#1			;X scroll
	strb r0,scrollX+1
	ldmfd sp!,{pc}
;----------------------------------------------------------------------------
ctrl1_W		;(2001)
;----------------------------------------------------------------------------
	strb r0,ppuctrl1

	ldr r1,=DISPCNT_INIT

	tst r0,#0x08		;bg en?
	beq cr10

	ldr r2,=emuflags
	ldr r2,[r2]
	tst r2,#ALPHALERP
	orrne r1,r1,#0x0300
	orreq r1,r1,#0x0100
cr10
	tst r0,#0x10		;obj en?
	orrne r1,r1,#0x1000

	tst r0,#0x02		;bg clip (obj clip will be forced too, from window oddities)
	orreq r1,r1,#0x2000
	tst r0,#0x04		;obj clip
	orreq r1,r1,#0x4000
		
	str r1,dispcnt
	mov pc,lr

dispcnt DCD DISPCNT_INIT
;----------------------------------------------------------------------------
stat_R		;(2002)
;----------------------------------------------------------------------------
	mov r0,#0
	strb r0,toggle

	ldr r0,sprite0y		;sprite0 hit?
	ldr r1,scanline
	cmp r1,r0
;	ble nosprh
;	ldrb r0,sprite0x	;for extra high resolution sprite0 hit
;	ldr r1,cyclesperscanline ;the store is in IO.s
;	sub r1,r1,cycles
;	cmp r1,r0
	ldrb r0,ppustat
	orrhi r0,r0,#0x40
;nosprh
	bic r1,r0,#0x80		;vbl flag clear
	strb r1,ppustat

	mov pc,lr
;----------------------------------------------------------------------------
bgscroll_W	;(2005)
;----------------------------------------------------------------------------
	ldrb r1,toggle
	eors r1,r1,#1
	strb r1,toggle
	beq bgscrollY
bgscrollX
	strb r0,scrollX
	mov pc,lr
bgscrollY
	strb r0,scrollYtemp

	ldr r1,vramaddr2	;yscroll modifies vramaddrtmp
	bic r1,r1,#0x7300
	bic r1,r1,#0x00e0
	and r2,r0,#0xf8
	and r0,r0,#7
	orr r1,r1,r2,lsl#2
	orr r1,r1,r0,lsl#12
	str r1,vramaddr2

	mov pc,lr
;----------------------------------------------------------------------------
vmaddr_W	;(2006)
;----------------------------------------------------------------------------
	ldrb r1,toggle
	eors r1,r1,#1
	strb r1,toggle
	beq low
high
	and r0,r0,#0x3f
	strb r0,vramaddr2+1
	mov pc,lr
low
	strb r0,vramaddr2
	ldr r1,vramaddr2
	str r1,vramaddr

	and r0,r1,#0x7000	;r0=fine Y
	and r2,r1,#0x03e0	;r2=coarse Y
	and addy,r1,#0x0800	;r12=high Y
	mov r0,r0,lsr#12
	orr r0,r0,r2,lsr#2
	orr r0,r0,addy,lsr#3
	str r0,scrollY
	str r0,scrollYtemp

	ldrb r0,scrollX
	and r0,r0,#7		;r0=fine X
	and r2,r1,#0x001f	;r1=coarse X
	and addy,r1,#0x0400	;r2=high X
	orr r0,r0,r2,lsl#3
	orr r0,r0,addy,lsr#2
	str r0,scrollX

	mov pc,lr
;----------------------------------------------------------------------------
vmdata_R	;(2007)
;----------------------------------------------------------------------------
	ldr r0,vramaddr
	ldrb r1,vramaddrinc
	bic r0,r0,#0xfc000
	add r2,r0,r1
	str r2,vramaddr

	cmp r0,#0x3f00
	bhs palread

	and r1,r0,#0x3c00
	adr r2,vram_map
	ldr r1,[r2,r1,lsr#8]
	bic r0,r0,#0xfc00

	ldrb r1,[r1,r0]
	ldrb r0,readtemp
	str r1,readtemp
	mov pc,lr
palread
	and r0,r0,#0x1f
	adr r1,nes_palette
	ldrb r0,[r1,r0]
	mov pc,lr
;----------------------------------------------------------------------------
vmdata_W	;(2007)
;----------------------------------------------------------------------------
	ldr addy,vramaddr
	ldrb r1,vramaddrinc
	bic addy,addy,#0xfc000 ;AND $3fff
	add r2,addy,r1
	str r2,vramaddr

	and r1,addy,#0x3c00
	adr r2,vram_write_tbl
	ldr pc,[r2,r1,lsr#8]
;----------------------------------------------------------------------------
VRAM_chr;	0000-1fff
;----------------------------------------------------------------------------
	ldr r2,=NES_VRAM
	strb r0,[r2,addy]

	bic addy,addy,#8
	ldrb r0,[r2,addy]!	;read 1st plane
	ldrb r1,[r2,#8]		;read 2nd plane

	adr r2,chr_decode
	ldr r0,[r2,r0,lsl#2]
	ldr r1,[r2,r1,lsl#2]
	orr r0,r0,r1,lsl#1

	and r2,addy,#7		;r2=tile line#
	add addy,addy,r2
	add r1,addy,addy
	add addy,r1,#NDS_OBJVRAM	;OBJ tileset
	add r1,r1,#NDS_VRAM		;BG tileset
	tst r1,#0x2000		;1st or 2nd page?
	addne r1,r1,#0x2000	;0000/4000 for BG, 10000/12000 for OBJ

	str r0,[r1]		;BG CHR
	str r0,[addy]		;OBJ CHR

	mov pc,lr
;----------------------------------------------------------------------------
VRAM_name0	;(2000-23ff)
;----------------------------------------------------------------------------
	ldr r1,nes_nt0
	ldr r2,agb_nt_map
writeBG		;loadcart jumps here
	bic addy,addy,#0xfc00	;AND $03ff
	strb r0,[r1,addy]
	cmp addy,#0x3c0
	bhs writeattrib
;writeNT
	add addy,addy,addy	;lsl#1
	ldrh r1,[r2,addy]	;use old color
	and r1,r1,#0xf000
	orr r1,r0,r1
	strh r1,[r2,addy]	;write tile#
	mov pc,lr
writeattrib
	stmfd sp!,{r3,r4,lr}

	orr r0,r0,r0,lsl#16
	and r1,addy,#0x38
	and addy,addy,#0x07
	add addy,addy,r1,lsl#2
	add addy,r2,addy,lsl#3
	ldr r3,=0x00ff00ff
	ldr r4,=0x00030003

	ldr r1,[addy]
	and r2,r0,r4
	and r1,r1,r3
	orr r1,r1,r2,lsl#12
	str r1,[addy]
		ldr r1,[addy,#0x40]
		and r1,r1,r3
		orr r1,r1,r2,lsl#12
		str r1,[addy,#0x40]
	ldr r1,[addy,#4]
	and r2,r0,r4,lsl#2
	and r1,r1,r3
	orr r1,r1,r2,lsl#10
	str r1,[addy,#4]
		ldr r1,[addy,#0x44]
		and r1,r1,r3
		orr r1,r1,r2,lsl#10
		str r1,[addy,#0x44]
	ldr r1,[addy,#0x80]
	and r2,r0,r4,lsl#4
	and r1,r1,r3
	orr r1,r1,r2,lsl#8
	str r1,[addy,#0x80]
		ldr r1,[addy,#0xc0]
		and r1,r1,r3
		orr r1,r1,r2,lsl#8
		str r1,[addy,#0xc0]
	ldr r1,[addy,#0x84]
	and r2,r0,r4,lsl#6
	and r1,r1,r3
	orr r1,r1,r2,lsl#6
	str r1,[addy,#0x84]
		ldr r1,[addy,#0xc4]
		and r1,r1,r3
		orr r1,r1,r2,lsl#6
		str r1,[addy,#0xc4]
	ldmfd sp!,{r3,r4,pc}
;----------------------------------------------------------------------------
VRAM_name1	;(2400-27ff)
;----------------------------------------------------------------------------
	ldr r1,nes_nt1
	ldr r2,agb_nt_map+4
	b writeBG
;----------------------------------------------------------------------------
VRAM_name2	;(2800-2bff)
;---------------------------------------------------------------------------
	ldr r1,nes_nt2
	ldr r2,agb_nt_map+8
	b writeBG
;----------------------------------------------------------------------------
VRAM_name3	;(2c00-2fff)
;----------------------------------------------------------------------------
	ldr r1,nes_nt3
	ldr r2,agb_nt_map+12
	b writeBG
;----------------------------------------------------------------------------
VRAM_pal	;($3F00-$3F1F)
;----------------------------------------------------------------------------
	cmp addy,#0x3f00
	bmi VRAM_name3

	and r0,r0,#0x3f		;(only colors 0-63 are valid)
	and addy,addy,#0x1f
		tst addy,#0x0f
		moveq addy,#0	;$10 mirror to $00
	adr r1,nes_palette
	strb r0,[r1,addy]	;store in nes palette

	add r0,r0,r0
	ldr r1,=MAPPED_RGB
;	ldr r0,[r1,r0,lsl#1]	;lookup RGB, unaligned read.
	ldrh r0,[r1,r0]			;lookup RGB
	adr r1,agb_pal
	add addy,addy,addy	;lsl#1
	strh r0,[r1,addy]	;store in agb palette
	mov pc,lr
;----------------------------------------------------------------------------
newframe	;called at NES scanline 0	(r0-r9 safe to use)
;----------------------------------------------------------------------------
	stmfd sp!,{r3-r9,lr}

	ldr r0,DMAlinestart	;init scaling stuff
	ldr r1,scale
	tst r1,#1
	addeq r0,r0,#0x4000
	str r0,DMAline

	bl updateOBJCHR		;(nes_zpage still valid here)
;-----------------------
	ldr r0,scrollYtemp
	str r0,scrollY
;------------------------
	mov r8,#NDS_PALETTE		;palette transfer
	ldr addy,=agb_pal
nf8	ldmia addy!,{r0-r7}
	stmia r8,{r0,r1}
	add r8,r8,#32
	stmia r8,{r2,r3}
	add r8,r8,#32
	stmia r8,{r4,r5}
	add r8,r8,#32
	stmia r8,{r6,r7}
	add r8,r8,#0x1a0
	tst r8,#0x200
	bne nf8			;(2nd pass: sprite pal)

	ldmfd sp!,{r3-r9,pc}

;----------------------------------------------------------------------------

agb_pal		% 32*2	;copy this to real AGB palette every frame
nes_palette	% 32	;NES $3F00-$3F1F

vram_write_tbl	;for vmdata_W, r0=data, addy=vram addr
	DCD 0
	DCD 0
	DCD 0
	DCD 0
	DCD 0
	DCD 0
	DCD 0
	DCD 0
	DCD VRAM_name0	;$2000
	DCD VRAM_name1	;$2400
	DCD VRAM_name2	;$2800
	DCD VRAM_name3	;$2c00
	DCD VRAM_name0	;$3000
	DCD VRAM_name1	;$3400
	DCD VRAM_name2	;$3800
	DCD VRAM_pal	;$3c00

vram_map	;for vmdata_R
	DCD 0			;0000
	DCD 0			;0400
	DCD 0			;0800
	DCD 0			;0c00
	DCD 0			;1000
	DCD 0			;1400
	DCD 0			;1800
	DCD 0			;1c00
nes_nt0 DCD NES_VRAM+0x2000	;2000
nes_nt1 DCD NES_VRAM+0x2000	;2400
nes_nt2 DCD NES_VRAM+0x2400	;2800
nes_nt3 DCD NES_VRAM+0x2400	;2c00
	DCD NES_VRAM+0x2C00	;3000
	DCD NES_VRAM+0x2C00	;3400
	DCD NES_VRAM+0x2C00	;3800
	DCD NES_VRAM+0x2C00	;3c00

agb_nt_map
	DCD 0,0,0,0

;----------------------------------------------------------------------------
BGCNT	EQU 0x1c00
m0000	DCD BGCNT+0x0000,NES_VRAM+0x2000,NES_VRAM+0x2000,NES_VRAM+0x2000,NES_VRAM+0x2000
	DCD NDS_BG+0x0000,NDS_BG+0x0000,NDS_BG+0x0000,NDS_BG+0x0000
m1111	DCD BGCNT+0x0100,NES_VRAM+0x2400,NES_VRAM+0x2400,NES_VRAM+0x2400,NES_VRAM+0x2400
	DCD NDS_BG+0x0800,NDS_BG+0x0800,NDS_BG+0x0800,NDS_BG+0x0800
m0101	DCD BGCNT+0x4000,NES_VRAM+0x2000,NES_VRAM+0x2400,NES_VRAM+0x2000,NES_VRAM+0x2400
	DCD NDS_BG+0x0000,NDS_BG+0x0800,NDS_BG+0x0000,NDS_BG+0x0800
m0011	DCD BGCNT+0x8000,NES_VRAM+0x2000,NES_VRAM+0x2000,NES_VRAM+0x2400,NES_VRAM+0x2400
	DCD NDS_BG+0x0000,NDS_BG+0x0000,NDS_BG+0x0800,NDS_BG+0x0800
m0123	DCD BGCNT+0xc000,NES_VRAM+0x2000,NES_VRAM+0x2400,NES_VRAM+0x2800,NES_VRAM+0x2c00
	DCD NDS_BG+0x0000,NDS_BG+0x0800,NDS_BG+0x1000,NDS_BG+0x1800
;----------------------------------------------------------------------------
mirrorKonami_
	movs r1,r0,lsr#2
	tst r0,#1
	bcc mirror2V_
;	bcs mirror1_
mirror1_
	adrne r0,m1111
	adreq r0,m0000
	b mirrorchange
mirror2V_
	adreq r0,m0101
	adrne r0,m0011
	b mirrorchange
mirror2H_
	adreq r0,m0011
	adrne r0,m0101
	b mirrorchange
mirror4_
	adr r0,m0123
mirrorchange
	ldrb r1,cartflags
	tst r1,#SCREEN4+VS
	ldrne r0,=m0123		;force 4way mirror for SCREEN4 or VS flags

	stmfd sp!,{r3-r5,lr}

		ldmia r0!,{r1}
		str r1,bg0cnt
		
		ldr r1,=nes_nt0
		ldmia r0!,{r2-r5}
		stmia r1,{r2-r5}
		
		ldr r1,=agb_nt_map
		ldmia r0!,{r2-r5}
		stmia r1,{r2-r5}
	
	ldmfd sp!,{r3-r5,pc}
;----------------------------------------------------------------------------
vrommask	DCD 0
vrombase	DCD 0

SLOTS		EQU 16		;slots available for BG CHR cache
agb_bg_map	% SLOTS*4	;cached BG groups
agb_obj_map	DCD 0,0		;cached OBJ groups
currentBG	DCD 0		;BG CHR set in use (*4)
nextBG		DCD 0		;next CHR set to replace

;----------------------------------------------------------------------------
resetCHR	;initialize CHR  - used by loadcart
;----------------------------------------------------------------------------
	stmfd sp!,{lr}

	mov r0,#-1
	adr r1,agb_bg_map
	mov r2,#SLOTS
	bl filler

	mov r0,#-1
	adr r1,agb_obj_map
	str r0,[r1],#4
	str r0,[r1],#4
	
	mov r0,#0
	DEBUGINFO BGMISS,r0
	str r0,currentBG
	str r0,nextBG
	
	mov r0,#0
	strb r0,ppuctrl0	;BG gets tileset 0 (ensures first banks get cached first for chr-ram)
	mov r0,#0	
	bl chr01234567_		;default CHR mapping
	bl updateBGCHR
	
	ldmfd sp!,{pc}
;---------------------------------------------------
writeCHRTBL	DCD chr0_,chr1_,chr2_,chr3_,chr4_,chr5_,chr6_,chr7_

chr0_
	mov r1,#0
	b chr1k
chr1_
	mov r1,#1
	b chr1k
chr2_
	mov r1,#2
	b chr1k
chr3_
	mov r1,#3
	b chr1k
chr4_
	mov r1,#4
	b chr1k
chr5_
	mov r1,#5
	b chr1k
chr6_
	mov r1,#6
	b chr1k
chr7_
	mov r1,#7
chr1k
	ldr r2,vrommask
	and r0,r0,r2,lsr#10

	adr r2,nes_chr_map
	strb r0,[r2,r1]
	
	ldr r2,vrombase
	add r0,r2,r0,lsl#10
	adr r2,vram_map
	str r0,[r2,r1,lsl#2]
	bx lr
;---------------------------------------------------
chr01_
	mov r1,#0
	b chr2k
chr23_
	mov r1,#2
	b chr2k
chr45_
	mov r1,#4
	b chr2k
chr67_
	mov r1,#6
	;b chr2k
chr2k
	ldr r2,vrommask
	and r0,r0,r2,lsr#11

	mov r0,r0,lsl#1
	adr r2,nes_chr_map
	strb r0,[r2,r1]!
	orr r0,r0,#1
	strb r0,[r2,#1]
	
	ldr r2,vrombase
	add r0,r2,r0,lsl#10
	adr r2,vram_map
	str r0,[r2,r1,lsl#2]!
	add r0,r0,#0x400
	str r0,[r2,#4]
	bx lr
;----------------------------------------------------------------------------
chr0123_
;----------------------------------------------------------------------------
	ldr r2,vrommask
	and r0,r0,r2,lsr#12

	orr r1,r0,r0,lsl#8
	orr r1,r1,r1,lsl#16
	ldr r2,=0x03020100
	orr r2,r2,r1,lsl#2
	str r2,nes_chr_map

	ldr r1,vrombase
	add r1,r1,r0,lsl#12
	str r1,vram_map
	add r1,r1,#0x400
	str r1,vram_map+4
	add r1,r1,#0x400
	str r1,vram_map+8
	add r1,r1,#0x400
	str r1,vram_map+12
	bx lr
;----------------------------------------------------------------------------
chr01234567_
;----------------------------------------------------------------------------
	ldr r2,vrommask
	and r0,r0,r2,lsr#13

	orr r1,r0,r0,lsl#8
	orr r1,r1,r1,lsl#16
	ldr r2,=0x03020100
	orr r2,r2,r1,lsl#3
	str r2,nes_chr_map
	ldr r2,=0x07060504
	orr r2,r2,r1,lsl#3
	str r2,nes_chr_map+4

	ldr r1,vrombase
	add r1,r1,r0,lsl#13
	str r1,vram_map
	add r1,r1,#0x400
	str r1,vram_map+4
	add r1,r1,#0x400
	str r1,vram_map+8
	add r1,r1,#0x400
	str r1,vram_map+12
	add r1,r1,#0x400
	b _4567
;----------------------------------------------------------------------------
chr4567_
;----------------------------------------------------------------------------
	ldr r2,vrommask
	and r0,r0,r2,lsr#12

	orr r1,r0,r0,lsl#8
	orr r1,r1,r1,lsl#16
	ldr r2,=0x03020100
	orr r2,r2,r1,lsl#2
	str r2,nes_chr_map+4

	ldr r1,vrombase
	add r1,r1,r0,lsl#12
_4567	str r1,vram_map+16
	add r1,r1,#0x400
	str r1,vram_map+20
	add r1,r1,#0x400
	str r1,vram_map+24
	add r1,r1,#0x400
	str r1,vram_map+28
	bx lr
;----------------------------------------------------------------------------
updateBGCHR	;see if BG CHR needs to change, setup BGxCNTBUFF
;----------------------------------------------------------------------------
	ldrb r2,ppuctrl0
	tst r2,#0x10
	ldreq r0,nes_chr_map
	ldrne r0,nes_chr_map+4	;r0=new bg chr group

	;ldr r1,chrline
	;ldr r2,scanline
	;cmp r2,#239
	;movhi r2,#239
	;sub r1,r2,r1
	;cmp r1,#3		;if(scanline-lastline<3)
	;movmi pc,lr		;	return

	stmfd sp!,{r2-r7,lr}
	bl bg_chr_req
	ldmfd sp!,{r2-r7,pc}
;----------------------------------------------------------------------------
updateOBJCHR	;sprite CHR update (r3-r7 killed)
;----------------------------------------------------------------------------
	ldrb r2,ppuctrl0frame
	tst r2,#0x20	;8x16?
	beq uc3
	mov r12,lr
	bl uc1
	bl uc2
	bx r12
uc3
	tst r2,#0x08
	bne uc2
uc1
	ldr r0,nes_chr_map
	ldr r1,agb_obj_map
	eors r1,r1,r0
	moveq pc,lr
	str r0,agb_obj_map
	ldr r5,=NDS_OBJVRAM
	adr r6,agb_obj_map
	b unpack_tiles
uc2
	ldr r0,nes_chr_map+4
	ldr r1,agb_obj_map+4
	eors r1,r1,r0
	moveq pc,lr
	str r0,agb_obj_map+4
	ldr r5,=NDS_OBJVRAM+0x2000
	adr r6,agb_obj_map+4
	b unpack_tiles
;----------------------------------------------------------------------------
bg_chr_req	;request BG CHR group in r0
;		r0=chr group (4 1k CHR pages)
;----------------------------------------------------------------------------
	adr r6,agb_bg_map

	mov r2,r6
	add r3,r6,#SLOTS*4
bcr0	ldr r1,[r2],#4
	cmp r0,r1
	beq cached
	cmp r2,r3
	bne bcr0
	
	DEBUGCOUNT BGMISS

	ldr r7,nextBG			;r7=group to replace
	ldr r1,[r6,r7]			;r1=old group
	str r0,[r6,r7]!			;save new group, r6=new chr map ptr
	add r2,r7,#4
	bic r2,r2,#-SLOTS*4
	str r2,nextBG			;increment nextBG
	eor r1,r1,r0
	
decodeptr	RN r2 ;mem_chr_decode
tilecount	RN r3
nesptr		RN r4 ;chr src
agbptr		RN r5 ;chr dst
bankptr		RN r6 ;vrom bank lookup ptr

	mov agbptr,#NDS_VRAM
	add agbptr,agbptr,r7,lsl#12	;0000/4000/8000/...

unpack_tiles	;r1=old^new, r5=CHR dst, r6=map ---------UPDATEOBJCHR JUMPS HERE

	ldr decodeptr,=CHR_DECODE
bg0	 tst r1,#0xff
	 ldrb r0,[bankptr],#1
	 mov r1,r1,lsr#8
	 addeq agbptr,agbptr,#0x800
	 beq bg2
	 mov tilecount,#64
	 ldr nesptr,vrombase
	 add nesptr,nesptr,r0,lsl#10	;bank#*$400

bg1	  ldrb r0,[nesptr],#1
	  ldrb r7,[nesptr,#7]
	  ldr r0,[decodeptr,r0,lsl#2]
	  ldr r7,[decodeptr,r7,lsl#2]
	  orr r0,r0,r7,lsl#1
	  str r0,[agbptr],#4
	  tst agbptr,#0x1f
	  bne bg1
	 subs tilecount,tilecount,#1
	 add nesptr,nesptr,#8
	 bne bg1
bg2	tst bankptr,#3
	bne bg0

	mov pc,lr

cached;--------------
	sub r2,r2,#4
	sub r7,r2,r6	;r7=group#*4
	str r7,currentBG
	mov pc,lr
;---------------------------------------------
	AREA dtcm, data

obj_tileset
	% 240

	END
